﻿Imports System.Collections.Generic

Public Class EditoraConcreta
    Implements Sujeito

    Private observadores As New List(Of Observador)()
    Private _novaEdicao As Boolean = False

    Public Sub NotificarObservadores() Implements Sujeito.NotificarObservadores
        For Each o As Observador In observadores
            o.Atualizar(Me)
        Next
    End Sub

    Public Sub RegistrarObservador(o As Observador) Implements Sujeito.RegistrarObservador
        observadores.Add(o)
    End Sub

    Public Sub RemoverObservador(o As Observador) Implements Sujeito.RemoverObservador
        observadores.Remove(o)
    End Sub

    Public Sub alterarEdicao()
        If _novaEdicao Then
            _novaEdicao = False
        Else
            _novaEdicao = True
        End If
        NotificarObservadores()
    End Sub

    Public Function getEdicao() As [Boolean]
        Return _novaEdicao
    End Function
End Class
